# Contribution guidelines
Interested in contributing to this awesome open source project? Awesome! We will keep it super simple. Here are some basic rules that you should abide by:

* Write [good commit messages](https://chris.beams.io/posts/git-commit/).
* Comment your code in a way that will allow others to understand it... a year later!
* Do not decrease the code coverage, unless you have an extremely good reason.
* Maintain the coding style, within each file and throughout the project, as consistent as possible.
* Code against an issue which you mention in your commit message and/or pull request. If an issue does not exist, create one.
* Write *atomic* unit tests with human readable names that clarify the business value they verify.
